/*
 * File:   main.c
 * Author: Mark
 *
 * Created on May 18, 2016, 3:41 PM
 */

#define _XTAL_FREQ 8000000
#include <xc.h>

// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable (PWRT disabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = ON        // Internal/External Switchover (Internal/External Switchover mode is enabled)
#pragma config FCMEN = ON       // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is enabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config VCAPEN = OFF     // Voltage Regulator Capacitor Enable (All VCAP pin functionality is disabled)
#pragma config PLLEN = ON       // PLL Enable (4x PLL enabled)
#pragma config STVREN = ON      // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LVP = ON         // Low-Voltage Programming Enable (Low-voltage programming enabled)



#include "eusart_lib.h"


void main(void) {
   uint8_t char_buff[20];
   
   OSCCON	= 0b01110000;	//8MHz clock
   PIE1	= 0b00000000;	//no peripherals on
   TRISA	= 0b00000000;	//In on RA5
   ANSELA	= 0;		//no analog inputs
//     OPTION_REG			= 0b10000000;	//no weak pull-ups, timer0 at OSC/4/2 = osc/ 8
  PORTA |= 0b00000000;

   eusart_initialize();  //initialize eusart: 9600bps hard coded

   GIE = 1;  // Enable Global Interrupt
   PEIE = 1; // Enable Peripheral Interrupt
   
   while(1) {
      eusart_puts("Test EUSART\n");
      eusart_puts("Enter Text> ");
      eusart_gets(char_buff );
      eusart_puts("\n\nText Entered :");
      eusart_puts(char_buff);
      eusart_puts(":\n\n");
    }
}

void interrupt INTERRUPT_InterruptManager(void) {
    // interrupt handler
    if (PIE1bits.RCIE == 1 && PIR1bits.RCIF == 1) {
        EUSART_Receive_ISR();
    } else if (PIE1bits.TXIE == 1 && PIR1bits.TXIF == 1) {
        EUSART_Transmit_ISR();
    } else {
        //Unhandled Interrupt
    }
}

